# Submit a custom object bulk job Submits a bulk job request for a bulk operation on the specified custom object records. A succcessful call returns a newly created bulk job. The job ID can be used to poll the job status or upload the CSV file if it is a create or update job. ### Limits This custom object bulk jobs have the following limits: * The concurrent bulk job limit per tenant is 5. Bulk jobs in accepted, pending, or in_progress status are counted towards the concurrent bulk job limit. * The bulk job execuation order is not guaranteed, which means the bulk job that you submit ealier may be executed later. * Only the users that have the "Delete Custom Objects" permission can create a delete bulk job. Only the users that have the "Edit Custom Objects" permission can create a create or update bulk job. See Platform Permissions for more information. Endpoint: POST /objects/jobs Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) API version that determines the response schema. The default version is used if this parameter is not included. Specify Zuora-Version in the request header if you expect a specific response schema. ## Request fields (application/json): - `filter` (object) Filters to determine which records to be deleted in the bulk delete operation. - `filter.conditions` (array, required) Group of field filter conditions that are evaluated in conjunction with each other using the AND operator. The minimum number of conditions is 1 and the maximum is 2. - `filter.conditions.field` (string, required) The object field that is evaluated. Only filterable fields can be evaluated in the filter. Example: "CreatedDate" - `filter.conditions.operator` (string, required) Enum: "EQ", "GT", "LT", "GE", "LE" - `filter.conditions.value` (any, required) The value that the filterable field is evaluated against in the filter. The data type of value is consistent with that of the field. Example: "2020-01-01T00:00:00.000Z" - `namespace` (string, required) The namespace of the object. Custom objects belong to the default namespace. Zuora standard objects belong to the com_zuora namespace. Bulk job operations on the following Zuora standard objects are supported: * SavedQuery Enum: "default", "com_zuora" - `object` (string, required) The object that the bulk operation performs on. Example: "passenger" - `operation` (string, required) The operation that the bulk job performs. Only the users that have the "Delete Custom Objects" permission can submit a delete bulk job request. Only the users that have the "Edit Custom Objects" permission can submit a create or update bulk job request. See [Platform Permissions](https://knowledgecenter.zuora.com/Billing/Tenant_Management/A_Administrator_Settings/User_Roles/h_Platform_Roles#Platform_Permissions) for more information. Enum: "delete", "create", "update" ## Response 200 fields (application/json): - `CreatedById` (string) The ID of the user who creates the job. Example: "7b39d73f-22e6-404a-b8e7-894f7620e91c" - `CreatedDate` (string) The time when the bulk job is created. Example: "2021-03-15T06:47:18Z" - `Id` (string) The custom object bulk job ID. Example: "ed4b9701-bafb-4976-8019-b08269430153" - `UpdatedById` (string) The ID of the user who updates the job. Example: "7b39d73f-22e6-404a-b8e7-894f7620e91c" - `UpdatedDate` (string) The time when the bulk job is updated. Example: "2021-03-15T06:47:18Z" - `error` (object) Example: {"code":71012560,"message":"Service limit reached, please retry later."} - `error.code` (integer) The error code. Example: 71012560 - `error.message` (string) The error message. Example: "Service limit reached, please retry later." - `namespace` (string) The namespace of the object. Custom objects belong to the default namespace. Zuora standard objects belong to the com_zuora namespace. Bulk job operations on the following Zuora standard objects are supported: * SavedQuery Enum: "default", "com_zuora" - `object` (string) The object to that the bulk operation performs on. Example: "passenger" - `operation` (string) The operation that the bulk job performs. Only the users that have the "Delete Custom Objects" permission can submit a delete bulk job request. Only the users that have the "Edit Custom Objects" permission can submit a create or update bulk job request. See [Platform Permissions](https://knowledgecenter.zuora.com/Billing/Tenant_Management/A_Administrator_Settings/User_Roles/h_Platform_Roles#Platform_Permissions) for more information. Enum: "delete", "create", "update" - `processingTime` (integer) The amount of time elapsed, in milliseconds, from the submission to the completion of the bulk job. Example: 1882 - `recordsProcessed` (integer) The number of object records processed by the bulk job. Example: 500 - `status` (string) The status of the bulk job: - accepted - The job has been accepted and is ready to process. - pending - The job is waiting for your input. You can use [Upload a file for a custom object bulk job](https://developer.zuora.com/api-references/api/operation/POST_UploadFileForCustomObjectBulkJob) to upload a file so that the job can start creating records. - in_progress - The job is processing. - completed - The job has completed. - failed - The job was unable to complete. You can use [List all errors for a custom object bulk job](https://developer.zuora.com/api-references/api/operation/GET_CustomObjectBulkJobErrors) to list the errors. - cancelled - The job was cancelled by the server. Enum: "accepted", "pending", "in_progress", "completed", "failed", "cancelled" ## Response 400 fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded. ## Response 403 fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.